/* Cygnus Help Files

   Cygnus IRC Services - Copyright (c) 2001-2002 Darcy Grexton
   Contact: skold@habber.net, skold @ HabberNet, ICQ #6285178

   This program is free but copyrighted software; see the file COPYING
   for details.
 */

#include "../inc/services.h"

void nickserv_help_index (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "\2%s\2 allows you to register nicknames. Once a nickname is",
	s_NickServ);
    notice (s_NickServ, source, "registered, you will be able to send and receive memos with");
    notice (s_NickServ, source, "\2%s\2, register channels with \2%s\2, and store information", s_MemoServ, s_ChanServ);
    notice (s_NickServ, source, "in \2%s\2.", s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "For more information on a specific topic, type:");
    notice (s_NickServ, source, "/%s%s%s%s HELP Topic\2", haveserv_on == TRUE ? "" :
	"MSG ", s_NickServ, haveserv_on == TRUE ? "" : securitysetting == 1 ? "@" :
	"", haveserv_on == TRUE ? "" : securitysetting == 1 ? me.name : "");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "\2%s\2 contains information on the following topics:",
	s_NickServ);
    notice (s_NickServ, source, " ");

    if (helpindex == 1)
    {
	notice (s_NickServ, source, "\2REGISTER DROP INFO IDENTIFY SET ACCESS RECOVER STATUS%s\2",
	    chanserv_on == TRUE ? " CHANS" : "");

	if (maxlinks)
	    notice (s_NickServ, source, "\2LINK UNLINK LINKS\2");

	if (is_csop (source))
	{
	    notice (s_NickServ, source, " ");
	    notice (s_NickServ, source, "\2CSOp or higher:\2");
	    notice (s_NickServ, source, "\2GETPASS SETPASS %sFREEZE UNFREEZE\2",
		email_on == TRUE ? "SENDPASS " : "");
	}

	if (is_sra (source))
	{
	    notice (s_NickServ, source, " ");
	    notice (s_NickServ, source, "\2SRA or higher:\2");
	    notice (s_NickServ, source, "\2HOLD UNHOLD MARK UNMARK\2");
	}
    }

    if (helpindex == 3)
    {
	notice (s_NickServ, source, "\2REGISTER\2        Register a nickname with \2%s\2", s_NickServ);
	notice (s_NickServ, source, "\2DROP\2            Drop a registered nickname");
	notice (s_NickServ, source, "\2INFO\2            Show information on a registered nickname");
	notice (s_NickServ, source, "\2IDENTIFY\2        Identify for a nickname");
	notice (s_NickServ, source, "\2SET\2             Modify various nickname settings");
	notice (s_NickServ, source, "\2ACCESS\2          Add, Remove or List nickname access list entries");
	notice (s_NickServ, source, "\2RECOVER\2         Recover a nickname from \2%s\2 or another user", s_NickServ);
	notice (s_NickServ, source, "\2STATUS\2          Show your current status to Services");

	if (chanserv_on == TRUE)
	    notice (s_NickServ, source, "\2CHANS\2           List channels registered under your nickname");

	if (maxlinks)
	{
	    notice (s_NickServ, source, "\2LINK\2            Link two nicknames together");
	    notice (s_NickServ, source, "\2UNLINK\2          Unlink two linked nicknames");
	    notice (s_NickServ, source, "\2LINKS\2           List nicknames linked to a nickname");
	}

	if (is_csop (source))
	{
	    notice (s_NickServ, source, "\2GETPASS\2         Retrieve the password for a nickname");
	    notice (s_NickServ, source, "\2SETPASS\2         Change the password for a nickname");

	    if (email_on == TRUE)
		notice (s_NickServ, source, "\2SENDPASS\2        E-Mail the password for a nickname");

	    notice (s_NickServ, source, "\2FREEZE\2          Freeze a nickname to prevent use of it");
	    notice (s_NickServ, source, "\2UNFREEZE\2        Undo a Freeze on a nickname");
	}

	if (is_sra (source))
	{
	    notice (s_NickServ, source, "\2HOLD\2            Hold a nickname to prevent it from expiring");
	    notice (s_NickServ, source, "\2UNHOLD\2          Undo a Hold on a nickname");
	    notice (s_NickServ, source, "\2MARK\2            Mark a nickname to prevent GET/SET/SENDPASSing");
	    notice (s_NickServ, source, "\2UNMARK\2          Undo a Mark on a nickname");
	}
    }

    if (helpindex == 2)
    {
	notice (s_NickServ, source, "\2REGISTER\2        Register a nickname with \2%s\2", s_NickServ);
	notice (s_NickServ, source, "\2DROP\2            Drop a registered nickname");
	notice (s_NickServ, source, "\2INFO\2            Show information on a registered nickname");
	notice (s_NickServ, source, "\2IDENTIFY\2        Identify for a nickname");
	notice (s_NickServ, source, "\2SET\2             Modify various nickname settings");

	notice (s_NickServ, source, " ");
	notice (s_NickServ, source, "Other commands: \2ACCESS RECOVER STATUS%s%s\2",
	    chanserv_on == TRUE ? " CHANS" : "", maxlinks ? " LINK" : "");

	if (maxlinks)
	    notice (s_NickServ, source, "                \2UNLINK LINKS\2");	

	if (is_csop (source))
	{
	    notice (s_NickServ, source, " ");
	    notice (s_NickServ, source, "\2CSOp or higher:\2");
	    notice (s_NickServ, source, "\2GETPASS SETPASS %sFREEZE UNFREEZE\2",
		email_on == TRUE ? "SENDPASS " : "");
	}

	if (is_sra (source))
	{
	    notice (s_NickServ, source, " ");
	    notice (s_NickServ, source, "\2SRA or higher:\2");
	    notice (s_NickServ, source, "\2HOLD UNHOLD MARK UNMARK\2");
	}
    }

    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_register (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");

    if (!nsregistertype)
	notice (s_NickServ, source, "Syntax: \2REGISTER Password\2");
    if (nsregistertype == 1)
	notice (s_NickServ, source, "Syntax: \2REGISTER E-Mail\2");
    if (nsregistertype == 2 || nsregistertype == 3)
	notice (s_NickServ, source, "Syntax: \2REGISTER Password E-Mail\2");
    if (nsregistertype == 4)
	notice (s_NickServ, source, "Syntax: \2REGISTER Password Password\2");
    if (nsregistertype == 5 || nsregistertype == 6)
	notice (s_NickServ, source, "Syntax: \2REGISTER Password Password E-Mail\2");

    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Allows you to register your nickname with \2%s\2.", s_NickServ);
    notice (s_NickServ, source, "Once your nickname is registered, you will be able to send");
    notice (s_NickServ, source, "and receive memos through \2%s\2, register channels", s_MemoServ);
    notice (s_NickServ, source, "and get access to other channels through \2%s\2,", s_ChanServ);
    notice (s_NickServ, source, "and manage your nickname through \2%s\2.", s_NickServ);
    notice (s_NickServ, source, " ");

    if (!nsregistertype || nsregistertype > 1)
    {
	notice (s_NickServ, source, "The password you give is case sensitive. Passwords must be");
	notice (s_NickServ, source, "at least 5 characters in length and no more than 32");
	notice (s_NickServ, source, "characters in length.");
    }

    if (nsregistertype == 1 || nsregistertype == 3 || nsregistertype == 6)
    {
	/* Add a blank line to have it look nice from above */
	if (!nsregistertype || nsregistertype > 1)
	    notice (s_NickServ, source, " ");

	notice (s_NickServ, source, "\2%s\2 will E-Mail you when you register.", s_NickServ);
	notice (s_NickServ, source, "You must follow the instructions in the E-Mail to");
	notice (s_NickServ, source, "complete registration of your nickname.");
    }

    notice (s_NickServ, source, " ");

    if (!nsregistertype)
	notice (s_NickServ, source, "Example: \2REGISTER PasSwORd\2");
    if (nsregistertype == 1)
	notice (s_NickServ, source, "Example: \2REGISTER your@email.com\2");
    if (nsregistertype == 2 || nsregistertype == 3)
	notice (s_NickServ, source, "Example: \2REGISTER PasSwORd your@email.com\2");
    if (nsregistertype == 4)
	notice (s_NickServ, source, "Example: \2REGISTER PasSwORd PasSwORd\2");
    if (nsregistertype == 5 || nsregistertype == 6)
	notice (s_NickServ, source, "Example: \2REGISTER PasSwORd PasSwORd your@email.com\2");

    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_drop (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2DROP NickName Password\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Drops the specified nickname. Once a nickname is dropped,");
    notice (s_NickServ, source, "it cannot be undone. It will be available for other users");
    notice (s_NickServ, source, "to register. Any nicknames linked to the dropped nickname");
    notice (s_NickServ, source, "will also be dropped.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "If you wish to drop a linked nickname, see the \2UNLINK\2");
    notice (s_NickServ, source, "command.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2DROP NickName PasSWORd\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_info (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2INFO NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Shows you information on a registered nickname,");
    notice (s_NickServ, source, "such as the time of registration, when the nickname");
    notice (s_NickServ, source, "was last used, and various other information.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2INFO NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_identify (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2IDENTIFY NickName Password\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Identify for access to a nickname. Once identified,");
    notice (s_NickServ, source, "you will be able to see and read any memos you have,");
    notice (s_NickServ, source, "gain ops in channels, and use your nickname.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2IDENTIFY NickName PasSWORd\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_set (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2SET Option Parameters\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Allows you to modify various nickname settings. You must");
    notice (s_NickServ, source, "\2IDENTIFY\2 for the nickname in order to change its settings.");
    notice (s_NickServ, source, "The settings you can modify are listed below:");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "\2PASS\2         Change your nickname password");

    if (email_on == TRUE)
	notice (s_NickServ, source, "\2EMAIL\2        Change your E-Mail address");

    if (url_on == TRUE)
	notice (s_NickServ, source, "\2URL\2          change your URL");

    if (uin_on == TRUE)
	notice (s_NickServ, source, "\2UIN\2          Change your ICQ UIN");

    if (name_on == TRUE)
	notice (s_NickServ, source, "\2NAME\2         Change your real name");

    if (age_on == TRUE)
	notice (s_NickServ, source, "\2AGE\2          Change your age");

    if (sex_on == TRUE)
	notice (s_NickServ, source, "\2SEX\2          Change your sex");

    if (location_on == TRUE)
	notice (s_NickServ, source, "\2LOCATION\2       Change your location");

    notice (s_NickServ, source, "\2ENFORCE\2      Enable nickname enforcement");
    notice (s_NickServ, source, "\2SECURE\2       Enable nickname security");

    if (showmail_on == TRUE && email_on == TRUE)
	notice (s_NickServ, source, "\2SHOWMAIL\2     Show your E-Mail address in \2INFO\2");

    if (showmail_on == FALSE && email_on == TRUE)
	notice (s_NickServ, source, "\2HIDEMAIL\2     Hide your E-Mail address in \2INFO\2");

#ifdef UNREAL3
    notice (s_NickServ, source, "\2NEVEROP\2      Stop \2%s\2 from auto voice/halfop/opping you", s_ChanServ);
#else
    notice (s_NickServ, source, "\2NEVEROP\2      Stop \2%s\2 from auto voice/opping you", s_ChanServ);
#endif
    notice (s_NickServ, source, "\2NOOP\2         Stop people from adding you to \2%s\2 access lists", s_ChanServ);
    notice (s_NickServ, source, "\2NOSUCCESSOR\2  Stop people from making you the successor of channels", s_ChanServ);

    if (privmsg_on == FALSE)
	notice (s_NickServ, source, "\2PRIVMSG\2      Make services PRIVMSG you instead of NOTICE");
    else
	notice (s_NickServ, source, "\2NOTICE\2       Make services NOTICE you instead of PRIVMSG");

    notice (s_NickServ, source, "\2PRIVATE\2      Keep your hostmask private in INFO");

    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2SET ENFORCE ON\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_access (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2ACCESS ADD|DEL|LIST|CURRENT\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Add, remove, or list nickname access list entries.");
    notice (s_NickServ, source, "Nickname access list entries help \2%s\2", s_NickServ);
    notice (s_NickServ, source, "recognize you without requiring you to \2IDENTIFY\2.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Use ACCESS CURRENT to have \2%s\2 remember", s_NickServ);
    notice (s_NickServ, source, "your current address.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2ACCESS ADD *@*.someisp.com\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_recover (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2RECOVER NickName Password\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Have \2%s\2 regain a nickname for use.", s_NickServ);
    notice (s_NickServ, source, "If your nickname is being held by \2%s\2,", s_NickServ);
    notice (s_NickServ, source, "or being used by someone else, this command will remove");
    notice (s_NickServ, source, "them from the network so you may use your nickname.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2RECOVER NickName PasSWORd\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_status (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2STATUS\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Show your current status to Services. This command will");
    notice (s_NickServ, source, "show what nickname you are identified to, if any, and any");
    notice (s_NickServ, source, "higher level access, such as IRCOp, CSOp and SRA.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2STATUS\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_link (const char *source)
{
    if (!maxlinks)
    {
	notice (s_NickServ, source, ERR_NO_HELP, "LINK");
	return;
    }

    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2LINK NickName [Password]\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Allows you to link two nicknames together. Once");
    notice (s_NickServ, source, "a nickname is linked to another, it shares the host");
    notice (s_NickServ, source, "nicknames access lists, passwords, memos, etc.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "If both nicknames are registered, then they are merged.");
    notice (s_NickServ, source, "The host nickname's information takes precedence for");
    notice (s_NickServ, source, "any duplicate information.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "If the nickname you specify is registered, but your current");
    notice (s_NickServ, source, "nickname is not, the specified nickname is the host.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "If the nickname you specify is not registered, but your");
    notice (s_NickServ, source, "current one is, your current nickname is the host. You do not");
    notice (s_NickServ, source, "need to give a password in this case.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "If both nicknames are registered, the specified nickname is");
    notice (s_NickServ, source, "the host. Your current nickname will be merged into it.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2LINK NickName PasSWORd\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_unlink (const char *source)
{
    if (!maxlinks)
    {
	notice (s_NickServ, source, ERR_NO_HELP, "UNLINK");
	return;
    }

    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2UNLINK NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Unlink two linked nicknames. When two nicknames are unlinked,");
    notice (s_NickServ, source, "they become seperate nicknames with identical information. If");
    notice (s_NickServ, source, "you wish to completely unregister a linked nickname, use the");
    notice (s_NickServ, source, "\2DROP\2 command.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2UNLINK NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_links (const char *source)
{
    if (!maxlinks)
    {
	notice (s_NickServ, source, ERR_NO_HELP, "LINKS");
	return;
    }

    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2LINKS\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Show what nicknames are currently linked to the nickname");
    notice (s_NickServ, source, "you have identified for. Note that this may not be your");
    notice (s_NickServ, source, "current nickname.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2LINKS\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_chans (const char *source)
{
    if (chanserv_on == FALSE)
    {
	notice (s_NickServ, source, ERR_NO_HELP, "CHANS");
	return;
    }

    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2CHANS\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Show what channels are currently registered to the nickname");
    notice (s_NickServ, source, "you have identified for. Note that this may not be your");
    notice (s_NickServ, source, "current nickname.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2CHANS\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_getpass (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2GETPASS NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Retrieves the password for a registered nickname. GETPASS");
    notice (s_NickServ, source, "should only be used when SENDPASS is unavailable.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2GETPASS NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_setpass (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2SETPASS NickName NewPass NewPass\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Changes the password for a registered nickname.");
    notice (s_NickServ, source, "You should choose a unique password, consisting of");
    notice (s_NickServ, source, "random letters and numbers, at least 8 characters");
    notice (s_NickServ, source, "in length.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2SETPASS NickName PasSWORd PasSWORd\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_sendpass (const char *source)
{
    if (email_on == TRUE)
    {
	notice (s_NickServ, source, ERR_NO_HELP, "SENDPASS");
	return;
    }

    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2SENDPASS NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "E-Mails the password for a registered nickname to the"); 
    notice (s_NickServ, source, "E-Mail address stored in \2%s\2. If no E-Mail is", s_NickServ);
    notice (s_NickServ, source, "stored, SENDPASS will fail. You should check \2%s\2 INFO", s_NickServ);
    notice (s_NickServ, source, "for the nickname to see if they have set a valid E-Mail before");
    notice (s_NickServ, source, "using SENDPASS.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2SENDPASS NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_freeze (const char *source)
{
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2FREEZE NickName [Reason]\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Freeze a nickname. Once a nickname is frozen, it cannot");
    notice (s_NickServ, source, "be used. Anyone attempting to use the nickname will");
    notice (s_NickServ, source, "have their nickname changed, or be removed from the network.");
    notice (s_NickServ, source, "FREEZE is permanent until undone with the UNFREEZE command.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "FREEZE should only be used for short periods to punish abusive");
    notice (s_NickServ, source, "users. Consider using the FORBID command to permanently ban");
    notice (s_NickServ, source, "a nickname.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Examples: \2FREEZE NickName\2");
    notice (s_NickServ, source, "          \2FREEZE NickName Do not abuse Services");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_unfreeze (const char *source)
{           
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2UNFREEZE NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Undo a Freeze on a nickname. The nickname will be");
    notice (s_NickServ, source, "usable by its owner again.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2UNFREEZE NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_hold (const char *source)
{           
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2HOLD NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Hold a nickname. When a nickname is held, it");
    notice (s_NickServ, source, "will not expire.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2HOLD NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_unhold (const char *source)
{           
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2UNHOLD NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "UnHold a nickname. The nickname will expire");
    notice (s_NickServ, source, "normally if it goes unused.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2UNHOLD NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_mark (const char *source)
{           
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2MARK NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Mark a nickname. Marked nicknames cannot be");
    notice (s_NickServ, source, "GET/SET/SENDPASSed by anyone but SRAs.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2MARK NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void nickserv_help_unmark (const char *source)
{           
    notice (s_NickServ, source, RPL_HELP_START, s_NickServ);
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Syntax: \2UNMARK NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "UnMark a nickname. The nickname will be able");
    notice (s_NickServ, source, "to be GET/SET/SENDPASSed by anyone with access");
    notice (s_NickServ, source, "to those commands.");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, "Example: \2UNMARK NickName\2");
    notice (s_NickServ, source, " ");
    notice (s_NickServ, source, RPL_HELP_END);
}

void chanserv_help_index (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "\2%s\2 allows you to register channels. Once a",
	s_ChanServ);
    notice (s_ChanServ, source, "channel is registered, you will be able to control who");

#ifdef UNREAL3
    notice (s_ChanServ, source, "gets opped, halfopped and voiced, who can join your");
#else
    notice (s_ChanServ, source, "gets opped and voiced, who can join your");
#endif

    notice (s_ChanServ, source, "channel, who can change the topic, and much more.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "For more information on a specific topic, type:");
    notice (s_ChanServ, source, "/%s%s%s%s HELP Topic\2", haveserv_on == TRUE ? "" :
	"MSG ", s_ChanServ, haveserv_on == TRUE ? "" : securitysetting == 1 ? "@" :
	"", haveserv_on == TRUE ? "" : securitysetting == 1 ? me.name : "");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "\2%s\2 contains information on the following topics:",
	s_ChanServ);
    notice (s_ChanServ, source, " ");

    if (helpindex == 1)
    {
#ifdef UNREAL3
	notice (s_ChanServ, source, "\2REGISTER DROP INFO IDENTIFY SET VOP HOP\2");
#else
	notice (s_ChanServ, source, "\2REGISTER DROP INFO IDENTIFY SET VOP\2");
#endif

#ifdef UNREAL3
	notice (s_ChanServ, source, "\2AOP SOP OP DEOP HALFOP DEHALFOP VOICE DEVOICE\2");
	notice (s_ChanServ, source, "\2AKICK COUNT\2");
#else
	notice (s_ChanServ, source, "\2AOP SOP AKICK OP DEOP VOICE DEVOICE COUNT\2");
#endif

	if (is_csop (source))
	    notice (s_ChanServ, source, "\2FREEZE UNFREEZE GETPASS SETPASS%s%s\2",
	    email_on == TRUE ? " SENDPASS" : "", csregistertype == 4 ? " AUTH" : "");
    }

    if (helpindex == 3)
    {
	notice (s_ChanServ, source, "\2REGISTER\2        Register a channel with \2%s\2", s_ChanServ);
	notice (s_ChanServ, source, "\2DROP\2            Drop a registered channel");
	notice (s_ChanServ, source, "\2INFO\2            Show information on a registered channel");
	notice (s_ChanServ, source, "\2IDENTIFY\2        Identify for a channel");
	notice (s_ChanServ, source, "\2SET\2             Modify various channel settings");
	notice (s_ChanServ, source, "\2VOP\2             Add, Remove, or List AutoVoices");

#ifdef UNREAL3
	notice (s_ChanServ, source, "\2HOP\2             Add, Remove, or List AutoHalfOps");
#endif

	notice (s_ChanServ, source, "\2AOP\2             Add, Remove, or List AutoOps");
	notice (s_ChanServ, source, "\2SOP\2             Add, Remove, or List SuperOps");
	notice (s_ChanServ, source, "\2OP\2              Op someone on a channel");
	notice (s_ChanServ, source, "\2DEOP\2            DeOp someone on a channel");
#ifdef UNREAL3
	notice (s_ChanServ, source, "\2HALFOP\2          HalfOp someone on a channel");
	notice (s_ChanServ, source, "\2DEHALFOP\2        DeHalfOp someone on a channel");
#endif
	notice (s_ChanServ, source, "\2VOICE\2           Voice someone on a channel");
	notice (s_ChanServ, source, "\2DEVOICE\2         DeVoice someone on a channel");
	notice (s_ChanServ, source, "\2AKICK\2           Add, Remove, or List AutoKicks");
	notice (s_ChanServ, source, "\2COUNT\2           Show access list totals for a channel");

	if (is_csop (source))
	{
	    notice (s_ChanServ, source, "\2FREEZE\2          Stop a channel from being used");
	    notice (s_ChanServ, source, "\2UNFREEZE\2        Undo a freeze and allow usage of a channel");

	    if (csregistertype == 4)
		notice (s_ChanServ, source, "\2AUTH\2            List channels awaiting authentication");

	    notice (s_ChanServ, source, "\2GETPASS\2         Get the password for a channel");
	    notice (s_ChanServ, source, "\2SETPASS\2         Change the password for a channel");

	    if (email_on == TRUE)
		notice (s_ChanServ, source, "\2SENDPASS\2        E-Mail a channel's password to the founder");
	}
    }

    if (helpindex == 2)
    {
	notice (s_ChanServ, source, "\2REGISTER\2        Register a channel with \2%s\2", s_ChanServ);
	notice (s_ChanServ, source, "\2DROP\2            Drop a registered channel");
	notice (s_ChanServ, source, "\2INFO\2            Show information on a registered channel");
	notice (s_ChanServ, source, "\2IDENTIFY\2        Identify for a channel");
	notice (s_ChanServ, source, "\2SET\2             Modify various channel settings");

	notice (s_ChanServ, source, " ");
	notice (s_ChanServ, source, "Other commands: \2VOP%s AOP SOP OP DEOP%s VOICE\2",
#ifdef UNREAL3
	    " HOP", " HALFOP DEHALFOP");
#else
	    "", "");
#endif
	notice (s_ChanServ, source, "                \2DEVOICE AKICK\2");

	if (is_csop (source))
	{
	    notice (s_ChanServ, source, " ");
	    notice (s_ChanServ, source, "\2CSOp or higher:\2");
	    notice (s_ChanServ, source, "\2FREEZE UNFREEZE GETPASS SETPASS%s%s\2",
		email_on == TRUE ? " SENDPASS" : "", csregistertype == 4 ? " AUTH" : "");
	}
    }

    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}


void chanserv_help_register (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");

    if (!csregistertype || csregistertype == 4)
	notice (s_ChanServ, source, "Syntax: \2REGISTER Channel Password\2");
    if (csregistertype == 1)
	notice (s_ChanServ, source, "Syntax: \2REGISTER Channel\2");
    if (csregistertype == 2 || csregistertype == 3)
	notice (s_ChanServ, source, "Syntax: \2REGISTER Channel Password Password\2");

    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Registers a channel under the nickname you've identified");
    notice (s_ChanServ, source, "for. Once a channel is registered, you can add VOPs,");
#ifdef UNREAL3
    notice (s_ChanServ, source, "HOPs, AOPs and SOPs, place AKicks, and generally manage");
#else
    notice (s_ChanServ, source, "AOPs and SOPs, place AKicks, and generally manage");
#endif
    notice (s_ChanServ, source, "your channel. Channel registration also effectively");
    notice (s_ChanServ, source, "prevents takeovers, and virtually eliminates the need");
    notice (s_ChanServ, source, "for a bot.");
    notice (s_ChanServ, source, " ");

    if (!csregistertype || csregistertype == 4)
	notice (s_ChanServ, source, "Example: \2REGISTER #Channel PaSsWoRd\2");
    if (csregistertype == 1)
	notice (s_ChanServ, source, "Example: \2REGISTER #Channel\2");
    if (csregistertype == 2 || csregistertype == 3)
	notice (s_ChanServ, source, "Example: \2REGISTER #Channel PaSsWoRd PaSsWoRd\2");

    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_drop (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2DROP Channel Password\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Drops a registered channel. Once a channel has been");
    notice (s_ChanServ, source, "dropped, it is free for anyone to register. You must");
    notice (s_ChanServ, source, "\2IDENTIFY\2 with \2%s\2 in order to use drop.", s_NickServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Example: \2DROP #Channel PaSsWoRd\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_info (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2INFO Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Shows you information on a registered channel.");
    notice (s_ChanServ, source, "Information such as the channel's founder, time of");
    notice (s_ChanServ, source, "registration, MLock, URL, etc is shown.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Example: \2INFO #Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_identify (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2IDENTIFY Channel Password\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Identifies for founder access for the given channel.");
    notice (s_ChanServ, source, "You must \2IDENTIFY\2 for the channel in order to change");
    notice (s_ChanServ, source, "the channel's settings.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Example: \2IDENTIFY #Channel PaSsWoRd\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_set (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2SET Channel Option Parameters\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Allows you to modify various channel settings. You must");
    notice (s_ChanServ, source, "\2IDENTIFY\2 with the founder password in order to change");
    notice (s_ChanServ, source, "channel settings. The settings you can modify are listed");
    notice (s_ChanServ, source, "below:");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "\2MLOCK\2        Set modes for \2%s\2 to enforce", s_ChanServ);
    notice (s_ChanServ, source, "\2SUCCESSOR\2    Select someone to inherit your channel");
    notice (s_ChanServ, source, "\2PASS\2         Change your channel's password");
    notice (s_ChanServ, source, "\2URL\2          Attach a URL to your channel");
    notice (s_ChanServ, source, "\2GREET\2        Change the channel's on join greeting message");
    notice (s_ChanServ, source, "\2TOPIC\2        Change the channel's topic");
    notice (s_ChanServ, source, "\2TOPICLOCK\2    Locks the channel topic to its current setting");
    notice (s_ChanServ, source, "\2VERBOSE\2      Notices your channel's ops for some commands");
    notice (s_ChanServ, source, "\2VOPALL\2       Voices everyone on join");
    notice (s_ChanServ, source, "\2SECURE\2       Makes \2%s\2 more strict about ops", s_ChanServ);
    notice (s_ChanServ, source, "\2RESTRICTED\2   Restrict your channel to people on op lists only");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2SET #Channel MLOCK +tnr-smlipk\2");
    notice (s_ChanServ, source, "          \2SET #Channel PASS N3wP4SswOrd N3wP4SswOrd\2");
    notice (s_ChanServ, source, "          \2SET #Channel URL http://www.example.net\2");
    notice (s_ChanServ, source, "          \2SET #Channel SECURE ON\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_count (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2COUNT Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Shows you totals for the number of VOPs, %sAOPs,",
#ifdef UNREAL3
	"HOPs, ");
#else
	"");
#endif
    notice (s_ChanServ, source, "SOPs and AutoKicks on the given channel.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Example: \2COUNT #Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_vop (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2VOP Channel ADD|DEL|LIST [Mask|Nickname]\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Allows you to add, delete, and list the AutoVoices on");
    notice (s_ChanServ, source, "your channel. Only registered nicknames can be added to");
    notice (s_ChanServ, source, "the VOP list.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2VOP #Channel ADD Nickname\2");
    notice (s_ChanServ, source, "          \2VOP #Channel DEL 3\2");
    notice (s_ChanServ, source, "          \2VOP #Channel LIST *nick*\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

#ifdef UNREAL3
void chanserv_help_hop (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2HOP Channel ADD|DEL|LIST [Mask|Nickname]\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Allows you to add, delete, and list the AutoHalfOps on");
    notice (s_ChanServ, source, "your channel. Only registered nicknames can be added to");
    notice (s_ChanServ, source, "the HOP list.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2HOP #Channel ADD Nickname\2");
    notice (s_ChanServ, source, "          \2HOP #Channel DEL 3\2");
    notice (s_ChanServ, source, "          \2HOP #Channel LIST *nick*\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}
#endif

void chanserv_help_aop (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2AOP Channel ADD|DEL|LIST [Mask|Nickname]\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Allows you to add, delete, and list the AutoOps on");
    notice (s_ChanServ, source, "your channel. Only registered nicknames can be added to");
    notice (s_ChanServ, source, "the AOP list.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2AOP #Channel ADD Nickname\2");
    notice (s_ChanServ, source, "          \2AOP #Channel DEL 3\2");
    notice (s_ChanServ, source, "          \2AOP #Channel LIST *nick*\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_sop (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2SOP Channel ADD|DEL|LIST [Mask|Nickname]\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Allows you to add, delete, and list the SuperOps on");
    notice (s_ChanServ, source, "your channel. Only registered nicknames can be added to");
    notice (s_ChanServ, source, "the SOP list.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2SOP #Channel ADD Nickname\2");
    notice (s_ChanServ, source, "          \2SOP #Channel DEL 3\2");
    notice (s_ChanServ, source, "          \2SOP #Channel LIST *nick*\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_op (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2OP Channel Nickname\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Tells \2%s\2 to op the specified nickname", s_ChanServ);
    notice (s_ChanServ, source, "on your channel. If you wish to op yourself, you can");
    notice (s_ChanServ, source, "omit the nickname.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2OP #Channel Nickname\2");
    notice (s_ChanServ, source, "          \2OP #Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_deop (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2DEOP Channel Nickname\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Tells \2%s\2 to deop the specified nickname", s_ChanServ);
    notice (s_ChanServ, source, "on your channel. If you wish to deop yourself, you can");
    notice (s_ChanServ, source, "omit the nickname.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2DEOP #Channel Nickname\2");
    notice (s_ChanServ, source, "          \2DEOP #Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

#ifdef UNREAL3
void chanserv_help_halfop (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2HALFOP Channel Nickname\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Tells \2%s\2 to halfop the specified nickname", s_ChanServ);
    notice (s_ChanServ, source, "on your channel. If you wish to halfop yourself, you can");
    notice (s_ChanServ, source, "omit the nickname.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2HALFOP #Channel Nickname\2");
    notice (s_ChanServ, source, "          \2HALFOP #Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_dehalfop (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2DEHALFOP Channel Nickname\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Tells \2%s\2 to dehalfop the specified nickname", s_ChanServ);
    notice (s_ChanServ, source, "on your channel. If you wish to dehalfop yourself, you can");
    notice (s_ChanServ, source, "omit the nickname.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2DEHALFOP #Channel Nickname\2");
    notice (s_ChanServ, source, "          \2DEHALFOP #Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}
#endif

void chanserv_help_voice (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2VOICE Channel Nickname\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Tells \2%s\2 to voice the specified nickname", s_ChanServ);
    notice (s_ChanServ, source, "on your channel. If you wish to voice yourself, you can");
    notice (s_ChanServ, source, "omit the nickname.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2VOICE #Channel Nickname\2");
    notice (s_ChanServ, source, "          \2VOICE #Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_devoice (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2DEVOICE Channel Nickname\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Tells \2%s\2 to devoice the specified nickname", s_ChanServ);
    notice (s_ChanServ, source, "on your channel. If you wish to devoice yourself, you can");
    notice (s_ChanServ, source, "omit the nickname.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2DEVOICE #Channel Nickname\2");
    notice (s_ChanServ, source, "          \2DEVOICE #Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_akick (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2AKICK Channel ADD|DEL|LIST [Mask] [Reason]\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Allows you to manage your channel's AutoKick list. Masks");
    notice (s_ChanServ, source, "on the AKick list will be kicked and banned upon joining");
    notice (s_ChanServ, source, "the channel. When adding AKicks, a reason can be optionally");
    notice (s_ChanServ, source, "given.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2AKICK #Channel ADD *@*.abuse.com Abuse\2");
    notice (s_ChanServ, source, "          \2AKICK #Channel DEL 5\2");
    notice (s_ChanServ, source, "          \2AKICK #Channel LIST *abuse*");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_freeze (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2FREEZE Channel Reason\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Stops usage of a channel. when a channel is frozen, users");
    notice (s_ChanServ, source, "who join it will be kicked and banned. The reason, time and");
    notice (s_ChanServ, source, "setter of the \2FREEZE\2 will be visible in the channel's info.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Example: \2FREEZE #Channel Spamming\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_unfreeze (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2UNFREEZE Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Undoes a \2FREEZE\2 on the channel, allowing it to be used again.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Example: \2UNFREEZE #Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_getpass (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2GETPASS Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Retrieves the password for a channel. \2GETPASS\2 should only");
    notice (s_ChanServ, source, "be used when \2SENDPASS\2 is not possible.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Example: \2GETPASS #Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_setpass (const char *source)
{
    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2SETPASS Channel NewPass NewPass\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Sets the password of the channel to a new one which you");
    notice (s_ChanServ, source, "specify. This should only be done after you have determined");
    notice (s_ChanServ, source, "the user is the actual founder of the channel and that a");
    notice (s_ChanServ, source, "\2SENDPASS\2 is not possible.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Example: \2SETPASS #Channel PaSsWoRd PaSsWoRd\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_sendpass (const char *source)
{
    if (email_on == FALSE)
    {
	notice (s_ChanServ, source, ERR_NO_HELP, "SENDPASS");
	return;
    }

    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2SENDPASS Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Makes \2%s\2 E-Mail the password for the channel", s_ChanServ);
    notice (s_ChanServ, source, "to the E-Mail address \2%s\2 has for the founder.", s_NickServ);
    notice (s_ChanServ, source, "You should always check that the E-Mail address saved in");
    notice (s_ChanServ, source, "\2%s\2 appears to be real.", s_NickServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Example: \2SENDPASS #Channel\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void chanserv_help_auth (const char *source)
{
    if (csregistertype != 4)
    {
	notice (s_ChanServ, source, ERR_NO_HELP, "AUTH");
	return;
    }

    notice (s_ChanServ, source, RPL_HELP_START, s_ChanServ);
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Syntax: \2AUTH VERIFY|DENY|LIST [Channel] [Reason]\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Allows you to verify, deny, or list channels awaiting");
    notice (s_ChanServ, source, "authentication. You should only deny authentication for");
    notice (s_ChanServ, source, "a channel which violates network policy. The length of");
    notice (s_ChanServ, source, "time the channel was waiting, and your nickname, will be");
    notice (s_ChanServ, source, "logged and shown to other CSOps. The owner of the channel");
    notice (s_ChanServ, source, "will not be informed who verified or denied their channel.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "If you are denying a channel, you may provide a reason. This");
    notice (s_ChanServ, source, "will be logged, and shown to the channel founder.");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, "Examples: \2AUTH VERIFY #Channel\2");
    notice (s_ChanServ, source, "          \2AUTH DENY #Channel\2");
    notice (s_ChanServ, source, "          \2AUTH LIST\2");
    notice (s_ChanServ, source, " ");
    notice (s_ChanServ, source, RPL_HELP_END);
}

void memoserv_help_index (const char *source)
{
    notice (s_MemoServ, source, RPL_HELP_START, s_MemoServ);
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "\2%s\2 allows you to send and receive memos to and",
	s_MemoServ);
    notice (s_MemoServ, source, "from other users with registered nicknames.");
    notice (s_MemoServ, source, "Memos can be up to 256 characters long.");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "For more information on a specific topic, type:");
    notice (s_MemoServ, source, "/%s%s%s%s HELP Topic\2", haveserv_on == TRUE ? "" :
	"MSG ", s_MemoServ, haveserv_on == TRUE ? "" : securitysetting == 1 ? "@" :
	"", haveserv_on == TRUE ? "" : securitysetting == 1 ? me.name : "");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "\2%s\2 contains information on the following topics:",
	s_MemoServ);
    notice (s_MemoServ, source, " ");

    if (helpindex == 1)
	notice (s_MemoServ, source, "\2SEND READ LIST DEL RECALL NEWS SET\2");

    if (helpindex == 3)
    {
	notice (s_MemoServ, source, "\2SEND\2            Send a memo to another registered nickname");
	notice (s_MemoServ, source, "\2READ\2            Read one or more of your memos");
	notice (s_MemoServ, source, "\2DEL\2             Delete one or more of your memos");
	notice (s_MemoServ, source, "\2LIST\2            List memos for your nick or another nick");
	notice (s_MemoServ, source, "\2RECALL\2          Recall a memo you've sent to another user");
	notice (s_MemoServ, source, "\2NEWS\2            View the latest network news");
	notice (s_MemoServ, source, "\2SET\2             Modify \2%s\2 settings for your nickname", s_MemoServ);
    }

    if (helpindex == 2)
    {
	notice (s_MemoServ, source, "\2SEND\2            Send a memo to another registered nickname");
	notice (s_MemoServ, source, "\2READ\2            Read one or more of your memos");
	notice (s_MemoServ, source, "\2DEL\2             Delete one or more of your memos");
	notice (s_MemoServ, source, "\2LIST\2            List memos for your nick or another nick");

	notice (s_MemoServ, source, " ");
	notice (s_MemoServ, source, "Other commands: \2RECALL NEWS SET\2");
    }

    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, RPL_HELP_END);
}

void memoserv_help_send (const char *source)
{
    notice (s_MemoServ, source, RPL_HELP_START, s_MemoServ);
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Syntax: \2SEND Nickname Text\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Sends a memo to another registered nickname. You must \2IDENTIFY\2");
    notice (s_MemoServ, source, "with \2%s\2 before you can send memos. Memos can only be", s_NickServ);
    notice (s_MemoServ, source, "up to 256 characters in length. If you decide later that you don't");
    notice (s_MemoServ, source, "want the memo you sent to be read, you can \2RECALL\2 the memo,");
    notice (s_MemoServ, source, "as long as the person you sent it to hasn't yet read it.");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Example: \2SEND Nickname Hey, how's it going?\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, RPL_HELP_END);
}

void memoserv_help_read (const char *source)
{
    notice (s_MemoServ, source, RPL_HELP_START, s_MemoServ);
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Syntax: \2READ Number|ALL|NEW\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Reads one or more of your memos. You can either specify a number");
    notice (s_MemoServ, source, "from \2LIST\2, which will show you a specific memo, ALL, which");
    notice (s_MemoServ, source, "will show you all of your memos, and NEW, which will show you");
    notice (s_MemoServ, source, "only memos you have not read yet.");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Examples: \2READ 2\2");
    notice (s_MemoServ, source, "          \2READ ALL\2");
    notice (s_MemoServ, source, "          \2READ NEW\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, RPL_HELP_END);
}

void memoserv_help_del (const char *source)
{
    notice (s_MemoServ, source, RPL_HELP_START, s_MemoServ);
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Syntax: \2DEL Number|ALL|READ\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Deletes one or more of your memos. You can either specify a number");
    notice (s_MemoServ, source, "from \2LIST\2, which will delete a specific memo, ALL, which will");
    notice (s_MemoServ, source, "delete all of your memos, or READ, which will delete memos you have");
    notice (s_MemoServ, source, "read.");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Examples: \2DEL 2\2");
    notice (s_MemoServ, source, "          \2DEL ALL\2");
    notice (s_MemoServ, source, "          \2DEL NEW\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, RPL_HELP_END);
}

void memoserv_help_list (const char *source)
{
    notice (s_MemoServ, source, RPL_HELP_START, s_MemoServ);
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Syntax: \2LIST [Nickname]\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Shows memos you have received. If you specify a nickname,");
    notice (s_MemoServ, source, "\2%s\2 will show memos you have sent to that nickname.", s_MemoServ);
    notice (s_MemoServ, source, "You can then \2RECALL\2 a specific memo you have sent to that user.");
    notice (s_MemoServ, source, "The first 10 characters of any memo will be shown to help you find");
    notice (s_MemoServ, source, "a specific memo.");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Examples: \2LIST\2");
    notice (s_MemoServ, source, "          \2LIST Nickname\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, RPL_HELP_END);
}

void memoserv_help_recall (const char *source)
{
    notice (s_MemoServ, source, RPL_HELP_START, s_MemoServ);
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Syntax: \2RECALL Nickname Number|ALL\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Allows you to recall a memo you have sent to someone. Once a memo");
    notice (s_MemoServ, source, "has been recalled, the person you sent it to will not be able to");
    notice (s_MemoServ, source, "read it. You can get a specific memo number to recall by using");
    notice (s_MemoServ, source, "the \2LIST Nickname\2 command.");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Examples: \2RECALL Nickname 2\2");
    notice (s_MemoServ, source, "          \2RECALL Nickname ALL");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, RPL_HELP_END);
}

void memoserv_help_set (const char *source)
{
    notice (s_MemoServ, source, RPL_HELP_START, s_MemoServ);
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Syntax: \2SET Option Parameters\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Allows you to modify various memo settings. You must \2IDENTIFY\2");
    notice (s_MemoServ, source, "for your nickname in order to change memo settings. The settings");
    notice (s_MemoServ, source, "you can modify are listed below:");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "\2RECEIPTS\2     Have \2%s\2 send you receipts for memos", s_MemoServ);
    notice (s_MemoServ, source, "\2MEMOBOX\2      Change the size of your memobox");
    notice (s_MemoServ, source, "\2NOMEMO\2       Deny all memos from everyone");

    if (memomail_on == TRUE)
        notice (s_MemoServ, source, "\2MEMOMAIL\2     Have memos E-Mailed to you");

    notice (s_MemoServ, source, "\2FORWARD\2      Have your memos forwarded to another nickname");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Examples: \2SET RECEIPTS ON\2");
    notice (s_MemoServ, source, "          \2SET MEMOBOX 5\2");
    notice (s_MemoServ, source, "          \2SET FORWARD Nickname\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, RPL_HELP_END);
}

void memoserv_help_news (const char *source)
{
    notice (s_MemoServ, source, RPL_HELP_START, s_MemoServ);
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Syntax: \2NEWS\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Shows you the network news. \2%s\2 will notify you if there", s_MemoServ);
    notice (s_MemoServ, source, "is new network news you haven't read yet.");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, "Example: \2NEWS\2");
    notice (s_MemoServ, source, " ");
    notice (s_MemoServ, source, RPL_HELP_END);
}

void rootserv_help_index (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "\2%s\2 gives IRC Operators greater control over", s_RootServ);
    notice (s_RootServ, source, "the network through the use of JUPEs, AKILLs, and other");
    notice (s_RootServ, source, "commands.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "For more information on a specific topic, type:");
    notice (s_RootServ, source, "/%s%s%s%s HELP Topic\2", haveserv_on == TRUE ? "" :
	"MSG ", s_RootServ, haveserv_on == TRUE ? "" : securitysetting == 1 ? "@" :
	"", haveserv_on == TRUE ? "" : securitysetting == 1 ? me.name : "");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "\2%s\2 contains information on the following topics:",
	s_RootServ);
    notice (s_RootServ, source, " ");

    if (helpindex == 1)
    {
	if (maxclones)
	    notice (s_RootServ, source, "\2JUPE AKILL STATS CLONES TRIGGER EXCEPTION %s%s AUTH\2",
		globalnoticer_on == TRUE ? "GLOBAL " : "",
		is_csop (source) ? "SEARCH " : "");
	else
	    notice (s_RootServ, source, "\2JUPE AKILL STATS %s%s AUTH\2",
		globalnoticer_on == TRUE ? "GLOBAL " : "",
		is_csop (source) ? "SEARCH " : "");

	if (is_sra (source))
	{
	    notice (s_RootServ, source, "\2DEAUTH SHUTDOWN RESTART CSOP RESETNEWS\2");

#ifdef RAWINJECT
	    notice (s_RootServ, source, "\2DEBUG UPDATE REHASH SETTINGS RAW INJECT\2");
#else
	    notice (s_RootServ, source, "\2DEBUG UPDATE REHASH SETTINGS\2");
#endif
	}
    }

    if (helpindex >= 2)
    {
	notice (s_RootServ, source, "\2JUPE\2            Jupiter a server or nick");
	notice (s_RootServ, source, "\2AKILL\2           Add, Remove, or List AutoKills");
	notice (s_RootServ, source, "\2STATS\2           Show statistics of the network and services");

	if (maxclones)
	{
	    notice (s_RootServ, source, "\2CLONES\2          List the current clones on the network");
	    notice (s_RootServ, source, "\2TRIGGER\2         Add, Remove, or List Triggers");
	    notice (s_RootServ, source, "\2EXCEPTION\2       Add, Remove, or List Exceptions");
	}

	if (globalnoticer_on == TRUE)
	    notice (s_RootServ, source, "\2GLOBAL\2          Send a global notice");

	if (is_csop (source))
	    notice (s_RootServ, source, "\2SEARCH\2          Search Cygnus' logfile");

	notice (s_RootServ, source, "\2AUTH\2            Authenticate as an SRA");

	if (is_sra (source))
	{
	    notice (s_RootServ, source, "\2DEAUTH\2          De-Authenticate as an SRA");
	    notice (s_RootServ, source, "\2SHUTDOWN\2        Terminate Cygnus");
	    notice (s_RootServ, source, "\2RESTART\2         Restart Cygnus");
#ifdef RAWINJECT
	    notice (s_RootServ, source, "\2RAW\2             Send information to the uplink");
	    notice (s_RootServ, source, "\2INJECT\2          Fake information from the uplink");
#endif
	    notice (s_RootServ, source, "\2CSOP\2            Add, Remove, or List CSOps");
	    notice (s_RootServ, source, "\2RESETNEWS\2       Reset the read news flag for all nicks");
	    notice (s_RootServ, source, "\2DEBUG\2           Set debugging level");
	    notice (s_RootServ, source, "\2UPDATE\2          Force a database update");
	    notice (s_RootServ, source, "\2REHASH\2          Re-Read %s", CONFIGFILE);
	    notice (s_RootServ, source, "\2SETTINGS\2        Show various Cygnus settings");
	}
    }

    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_global (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2GLOBAL Message\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Sends a global notice. If your TLD setting is correct, all users");
    notice (s_RootServ, source, "on the network will see the notice.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2GLOBAL We are doing some routing.\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_jupe (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2JUPE Server|User [Reason]\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Jupiters the specified server or user. This will remove");
    notice (s_RootServ, source, "the server or user from the network if it already exists.");
    notice (s_RootServ, source, "Jupes will remain in place until SQUIT/KILLed, or until");
    notice (s_RootServ, source, "Cygnus is reset. If a reason is given, it will be used");
    notice (s_RootServ, source, "in any SQUIT/KILL of an existing server/user, and in the");
    notice (s_RootServ, source, "jupe's description/realname.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Examples: \2JUPE server.example.net Delinked\2");
    notice (s_RootServ, source, "          \2JUPE someuser This nick may not be used.\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_clones (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2CLONES Pattern [Limit]\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Lists the current clones on the network. Only hostnames matching");
    notice (s_RootServ, source, "Pattern will be shown. Use * to show all clones. If you give Limit,");
    notice (s_RootServ, source, "only Limit matching hosts will be shown.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Regardless of the given Limit, no more than 250 matches will be shown.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Examples: \2CLONES *hostname.com 25\2");
    notice (s_RootServ, source, "          \2CLONES *\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_akill (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2AKILL ADD|DEL|LIST [Mask|Number|Option]\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Allows you to add, remove, or list AutoKills. There are a");
    notice (s_RootServ, source, "number of parameters for each command:");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "\2ADD Mask|Nick [!P] [!R] [!T Expire Time] Reason\2 - The expire");
    notice (s_RootServ, source, "time is optional. If no expire time is given, the default will");
    notice (s_RootServ, source, "be used. Expire times are in the format of Days, Hours, Minutes,");
    notice (s_RootServ, source, "Seconds. For example, an expire time of 5 days, 1 hour and 30");
    notice (s_RootServ, source, "minutes would be 5d1h30m. You must give the \2!T\2 token to");
    notice (s_RootServ, source, "have an expire time understood. If the \2!R\2 token is given,");
    notice (s_RootServ, source, "Cygnus will treat the mask as a realname, and will AKill");
    notice (s_RootServ, source, "any users with matching realnames. If the \2!P\2 token is given,");
    notice (s_RootServ, source, "the AKill will never expire. If both the \2!T\2 and \2!P\2 tokens are");
    notice (s_RootServ, source, "given, The \2!P\2 token will have no effect. If you give a nickname");
    notice (s_RootServ, source, "instead of a mask, Cygnus will find that user's mask and");
    notice (s_RootServ, source, "AutoKill it. If the user is not online, you will have to provide");
    notice (s_RootServ, source, "a valid mask. The \2!P\2 token must always be given before the \2!R\2");
    notice (s_RootServ, source, "token, and the \2!R\2 token must always be given before the \2!T\2");
    notice (s_RootServ, source, "token.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "\2DEL Mask|Number|ALL\2 - Remove an AutoKill.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "\2LIST [FULL] [Match]\2 - Search for an AKill. If the");
    notice (s_RootServ, source, "first parameter is \2FULL\2, AKill reasons will be displayed,");
    notice (s_RootServ, source, "otherwise they will be omitted. If \2Match\2 is specified, it");
    notice (s_RootServ, source, "will be matched against the AKill mask and setter.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Examples: \2AKILL ADD *@*.someisp.com You are not welcome.\2");
    notice (s_RootServ, source, "          \2AKILL ADD *@*.someisp.com !T 5d1h30m You are not welcome.\2");
    notice (s_RootServ, source, "          \2AKILL ADD *@*.someisp.com !P You are not welcome.\2");
    notice (s_RootServ, source, "          \2AKILL ADD *sub7* !R Sub7 - You are not welcome.\2");
    notice (s_RootServ, source, "          \2AKILL ADD *sub7* !R !T 10d Sub7 - You are not welcome.\2");
    notice (s_RootServ, source, "          \2AKILL DEL *@*.someisp.com\2");
    notice (s_RootServ, source, "          \2AKILL DEL 25\2");
    notice (s_RootServ, source, "          \2AKILL DEL ALL\2");
    notice (s_RootServ, source, "          \2AKILL LIST\2");
    notice (s_RootServ, source, "          \2AKILL LIST *match*\2");
    notice (s_RootServ, source, "          \2AKILL LIST FULL\2");
    notice (s_RootServ, source, "          \2AKILL LIST FULL *match*\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_trigger (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2TRIGGER ADD|DEL|LIST [Host|Number|ALL] [Limit]");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Allows you to add, remove or list Triggers. A Trigger allows");
    notice (s_RootServ, source, "the Triggered host to have the defined number of connections.");
    notice (s_RootServ, source, "This allows you to set individual limits for certain hosts, such");
    notice (s_RootServ, source, "as your network's channel and nickname services.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Examples: \2TRIGGER ADD service@example.net 20\2");
    notice (s_RootServ, source, "          \2TRIGGER DEL 1\2");
    notice (s_RootServ, source, "          \2TRIGGER DEL ALL\2");
    notice (s_RootServ, source, "          \2TRIGGER DEL service@example.net\2");
    notice (s_RootServ, source, "          \2TRIGGER LIST\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_exception (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2EXCEPTION ADD|DEL|LIST [Host|Number|ALL]");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Allows you to add, remove or list Exceptions. An Exception allows");
    notice (s_RootServ, source, "the specified host to have total immunity to clone detection.");
    notice (s_RootServ, source, "Exceptions also override any Trigger-set limits.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Examples: \2EXCEPTION ADD service@example.net\2");
    notice (s_RootServ, source, "          \2EXCEPTION DEL 1\2");
    notice (s_RootServ, source, "          \2EXCEPTION DEL ALL\2");
    notice (s_RootServ, source, "          \2EXCEPTION DEL service@example.net\2");
    notice (s_RootServ, source, "          \2EXCEPTION LIST\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_stats (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2STATS\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Shows statistics on the network and services, such as uptime,");
    notice (s_RootServ, source, "current user, channel and server counts, and counts for nicknames,");
    notice (s_RootServ, source, "channels, memos, etc.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2STATS\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_auth (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2AUTH NickName Password\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Allows you to authenticate for SRA access. Once you have");
    notice (s_RootServ, source, "authenticated, you will be recognized as an SRA until you");
    notice (s_RootServ, source, "disconnect from the network or \2DEAUTH\2.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2AUTH SRANick SRAPass\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_deauth (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2DEAUTH\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Causes you to no longer be recognized as an SRA. You will");
    notice (s_RootServ, source, "need to re-\2AUTH\2 to regain SRA access.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2DEAUTH\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_shutdown (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2SHUTDOWN [NOSAVE] [Reason]\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Causes Cygnus to terminate. If you give the NOSAVE token,");
    notice (s_RootServ, source, "the DBs will not be saved. Otherwise, they will be updated before");
    notice (s_RootServ, source, "Cygnus shuts down. If you give a reason, this will be used in a");
    notice (s_RootServ, source, "GlobOps and a log entry.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Examples: \2SHUTDOWN\2");
    notice (s_RootServ, source, "          \2SHUTDOWN NOSAVE Reason\2");
    notice (s_RootServ, source, "          \2SHUTDOWN Reason\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_restart (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2RESTART [NOSAVE] [Reason]\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Causes Cygnus to restart. If you give the NOSAVE token,");
    notice (s_RootServ, source, "the DBs will not be saved. Otherwise, they will be updated before");
    notice (s_RootServ, source, "Cygnus shuts down. If you give a reason, this will be used in a");
    notice (s_RootServ, source, "GlobOps and a log entry.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Examples: \2RESTART\2");
    notice (s_RootServ, source, "          \2RESTART NOSAVE Reason\2");
    notice (s_RootServ, source, "          \2RESTART Reason\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_search (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2SEARCH MatchText [Num]\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Allows you to search Cygnus' logfiles for specific text.");
    notice (s_RootServ, source, "If \2Num\2 is specified, that amount of matches will be shown.");
    notice (s_RootServ, source, "\2Num\2 defaults to 50, and cannot be more than 250.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2SEARCH *akill* 25\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

#ifdef RAWINJECT
void rootserv_help_raw (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2RAW Data\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Sends information to Cygnus' uplink. Syntax is important.");
    notice (s_RootServ, source, "There is no limit to what you can do with \2RAW\2, provided");
    notice (s_RootServ, source, "your IRCd supports it.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "The \2RAW\2 command is not supported in any way.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2RAW SVSNICK OldNick NewNick :0\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_inject (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2INJECT Data\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Fakes information from Cygnus' uplink. Only certain information");
    notice (s_RootServ, source, "will be processed. See process.c for examples on what types of");
    notice (s_RootServ, source, "information will be processed. Note that misuse of this command");
    notice (s_RootServ, source, "(such as injecting a QUIT from a user) WILL cause Cygnus to be");
    notice (s_RootServ, source, "desync'd from the network and may cause crashes.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "The \2INJECT\2 command is not supported in any way.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2INJECT :User PRIVMSG StatServ :STATS\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}
#endif /* RAWINJECT */

void rootserv_help_csop (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: CSOP ADD|DEL|LIST [Nickname|Number|Pattern] [Max]");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Allows you to manage the CSOp list. CSOps have higher access");
    notice (s_RootServ, source, "than IRCOps, but not as much as SRAs. CSOps can use the");
    notice (s_RootServ, source, "\2GET/SET/SENDPASS\2 commands, \2FREEZE\2, and other commands.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Examples: \2CSOP ADD Nickname\2");
    notice (s_RootServ, source, "          \2CSOP DEL 3");
    notice (s_RootServ, source, "          \2CSOP LIST *nick*");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_debug (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2DEBUG Level\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Sets the debugging level. There are 4 debug mode levels:");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "    \2Level 0\2: No debug logging (disabled)");
    notice (s_RootServ, source, "    \2Level 1\2: Server<->server traffic is logged.");
    notice (s_RootServ, source, "    \2Level 2\2: Function calls are logged.");
    notice (s_RootServ, source, "    \2Level 3\2: Server<->server traffic & function calls are logged");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Logging will be done in debug.log, not %s", LOGFILE);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2DEBUG 3\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_update (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2UPDATE\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Forces Cygnus to save the DBs to disk. This will also");
    notice (s_RootServ, source, "reset the sync timer.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2UPDATE\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_rehash (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2REHASH\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Re-Reads %s. If you have any invalid settings, this", CONFIGFILE);
    notice (s_RootServ, source, "will cause Cygnus to shut down. The DBs will be saved to disk");
    notice (s_RootServ, source, "beforehand in case this happens.");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2REHASH\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_settings (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2SETTINGS\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Shows various Cygnus settings as defined in %s.", CONFIGFILE);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2SETTINGS\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}

void rootserv_help_resetnews (const char *source)
{
    notice (s_RootServ, source, RPL_HELP_START, s_RootServ);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Syntax: \2RESETNEWS\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Resets the NF_NEWS flag on every nickname, causing \2%s\2", s_MemoServ);
    notice (s_RootServ, source, "to notify users about new news. This should only be done when the");
    notice (s_RootServ, source, "%s file has been updated.", NEWSFILE);
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, "Example: \2RESETNEWS\2");
    notice (s_RootServ, source, " ");
    notice (s_RootServ, source, RPL_HELP_END);
}
